unit ExIniFiles;

interface
uses
  Forms, Windows, Classes, SysUtils, ShlObj, Controls, IniFiles, Graphics, TypInfo,
  StrToken;
type
  TMemIniFileEx = class(TMemIniFile)
  private
    { Private 錾 }
    mSection:String;
    procedure SetValue(const Ident,Value: String);
    function  GetValue(const Ident: String): String;
    function  GetValueCount(const Section: String): Integer;
    procedure SetSectionText(const Section,Value: String);
    function  GetSectionText(const Section: String): String;
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor CreateDef();
    constructor CreateExpand(FileName:TFileName);
    // ֗vpeB
    property  Section           : String                        read  mSection        write mSection;
    property  ValueCount        [const Section: String]: Integer read  GetValueCount;
    property  Values            [const Ident: String]  : String  read  GetValue        write SetValue; default;
    property  SectionText       [const Section: String]: String  read  GetSectionText  write SetSectionText;
    // V[gANZXp\bh
    procedure WriteStringS      (const Ident, Value:String);
    function  ReadStringS       (const Ident: String; Default: String = ''): String;
    //
    procedure WriteIntegerS     (const Ident: String; Value: Integer);
    function  ReadIntegerS      (const Ident: String; Default: Integer = 0): Integer;
    //
    procedure WriteBoolS        (const Ident: String; Value: Boolean);
    function  ReadBoolS         (const Ident: String; Default: Boolean = false): Boolean;
    //
    procedure WriteDateTimeS    (const Ident: String; Value: TDateTime);
    function  ReadDateTimeS     (const Ident: String; Default: TDateTime = 0): TDateTime;
    //
    procedure WriteFloatS       (const Ident: String; Value: Double);
    function  ReadFloatS        (const Ident: String; Default: Double = 0): Double;
    //
    procedure WritePathS        (const Ident: String; Value: TFileName);
    function  ReadPathS         (const Ident: String; Default: TFileName = ''): TFileName;
    //
    procedure WritePathRelativeS(const Ident: String; Value: TFileName);
    function  ReadPathRelativeS (const Ident: String; Default: TFileName = ''): TFileName;
    //
    procedure WritePointS       (const Ident: String; Value: TPoint);
    function  ReadPointS        (const Ident: String; Default: TPoint): TPoint;
    //
    procedure WriteRectS        (const Ident: String; Value: TRect);
    function  ReadRectS         (const Ident: String; Default: TRect): TRect;
    //
    procedure WriteFontS        (const Ident: String; Value: TFont);
    function  ReadFontS         (const Ident: String; Value: TFont): Boolean;
    //
    procedure WriteColorS       (const Ident: String; Value: TColor);
    function  ReadColorS        (const Ident: String; Default: TColor=clNone): TColor;
    // ǉ\bh
    procedure WritePath         (const Section, Ident:String;const Value: TFileName);
    function  ReadPath          (const Section, Ident:String;const Default: TFileName): TFileName;
    //
    procedure WritePathRelative (const Section, Ident:String;const Value: TFileName);
    function  ReadPathRelative  (const Section, Ident:String;const Default: TFileName): TFileName;
    //
    procedure WritePoint        (const Section, Ident:String;const Value: TPoint);
    function  ReadPoint         (const Section, Ident:String;const Default: TPoint): TPoint;
    //
    procedure WriteRect         (const Section, Ident:String;const Value: TRect);
    function  ReadRect          (const Section, Ident:String;const Default: TRect): TRect;
    //
    procedure WriteFont         (const Section, Ident:String;const Value: TFont);
    function  ReadFont          (const Section, Ident:String;var Value: TFont): Boolean;
    //
    procedure WriteLines        (const Section:String;Strings:TStrings;Saveline:Boolean=false);
    function  ReadLines         (const Section:String;Strings:TStrings): Boolean;
    //
    procedure WriteColor        (const Section, Ident:String;const Value: TColor);
    function  ReadColor         (const Section, Ident:String;Default: TColor): TColor;
  end;

  procedure GetPaths;
  function ExpandPath(Path:TFileName): TFileName;
  function ExtractPath(Path:TFileName): TFileName;
const
  pvPersonal    = '%PERSONAL%';
  pvMyMusic     = '%MYMUSIC%';
  pvAppData     = '%APPDATA%';
  pvComAppData  = '%COMMON_APPDATA%';
  pvWindows     = '%WINDOWS%';
  pvSystem      = '%SYSTEMS%';
  pvProgramFiles= '%PROGRAM_FILES%';
  pvMyPictures  = '%MYPICTURES%';
  pvProfile     = '%PROFILE%';
  pvPFC         = '%PROGRAM_FILES_COMMON%';
  pvApp         = '%APPLICATION%';
  pvUser        = '%USERNAME%';
implementation

uses Types;
type
  TPathData     = record
    CSIDL       : Integer;
    SubCSIDL    : Integer;
    VarName     : String;
  end;
const
  SP_APP              = $1000;
  SP_WINDOWS          = $1001;
  SP_SYSTEM           = $1002;
  SP_USER             = $1003;
  CSIDL_MYMUSIC       = $000D;
  CSIDL_COMMON_APPDATA= $001C;
  CSIDL_PROGRAM_FILES = $0026;
  CSIDL_MYPICTURES    = $0027;
  CSIDL_PROFILE       = $0028;
  CSIDL_PFC           = $002B;
  PathDatas : array[0..11] of TPathData= (
    (CSIDL:CSIDL_PERSONAL;      VarName:pvPersonal),
    (CSIDL:CSIDL_MYMUSIC;       SubCSIDL:CSIDL_PERSONAL;
      VarName:pvMyMusic),
    (CSIDL:CSIDL_APPDATA;       SubCSIDL:CSIDL_PERSONAL;
      VarName:pvAppData),
    (CSIDL:CSIDL_COMMON_APPDATA;SubCSIDL:CSIDL_PERSONAL;
      VarName:pvComAppData),
    (CSIDL:SP_WINDOWS;          VarName:pvWindows),
    (CSIDL:SP_SYSTEM;           VarName:pvSystem),
    (CSIDL:CSIDL_PROGRAM_FILES; SubCSIDL:SP_WINDOWS;
      VarName:pvProgramFiles),
    (CSIDL:CSIDL_MYPICTURES;    SubCSIDL:CSIDL_PERSONAL;
      VarName:pvMyPictures),
    (CSIDL:CSIDL_PROFILE;       SubCSIDL:CSIDL_PERSONAL;
      VarName:pvProfile),
    (CSIDL:CSIDL_PFC;           SubCSIDL:SP_SYSTEM;
      VarName:pvPFC),
    (CSIDL:SP_APP;              VarName:pvApp),
    (CSIDL:SP_USER;             VarName:pvUser)
  );
var
  appdir  : String;
  PathList: TStringList;

  function Paths(): TStringList;
  begin
    if not Assigned(PathList) then PathList := TStringList.Create;
    Result := PathList;
  end;

  procedure GetPaths();
    // \̂ɑS̕ϐۑ
  var
    i   : Integer;
    t   : Cardinal;
    Path: array[0..MAX_PATH] of Char;
    IDs : PItemIDList;
  begin
    for i := 0 to High(PathDatas) do begin
      case PathDatas[i].CSIDL of
        SP_APP: StrCopy(Path, PChar(appdir));
        SP_USER:begin
          t := MAX_PATH - 1;
          GetUserName(Path, t);
        end;
        SP_WINDOWS:begin
          GetWindowsDirectory(Path,MAX_PATH);
        end;
        SP_SYSTEM:begin
          GetSystemDirectory(Path,MAX_PATH);
        end;
      else begin
        if SHGetSpecialFolderLocation(0,PathDatas[i].CSIDL,IDs) <> NOERROR then
          SHGetSpecialFolderLocation(0,PathDatas[i].SubCSIDL,IDs);
        SHGetPathFromIDList(IDs,Path);
      end;
      end;
      Paths.Add(Format('%s=%s', [PathDatas[i].VarName, Path]));
    end;
  end;
  //
  function ExpandPath(Path:TFileName): TFileName;
    // ϐWJ
  var i,l : Integer;
  begin
    Result := Path;
    for i := 0 to Paths.Count - 1 do begin
      l := Length(PathDatas[i].VarName);
      if Copy(Path,1,l) = PathDatas[i].VarName then
        Result := Paths[i] + Copy(Path,l + 1,MAX_PATH);
    end;
  end;
  //
  function ExtractPath(Path:TFileName): TFileName;
    // pX̐擪ϐ
  var i,l : Integer;
  begin
    Result := Path;
    for i := 0 to High(PathDatas) do begin
      l := Length(Paths[i]);
      if Copy(Path,1,l) = Paths[i] then
        Result := PathDatas[i].VarName + Copy(Path,l + 1,MAX_PATH);
    end;
  end;

////////////////////////////////////////////////////////////////////////////////
// TMemIniFileEx
////////////////////////////////////////////////////////////////////////////////
// ǉRXgN^(EXEƓÕt@CIɐ)
constructor TMemIniFileEx.CreateDef();
begin
  inherited Create(ChangeFileExt(Application.ExeName,'.ini'));
end;

// ǉRXgN^2(ϐWJ\o[W)
constructor TMemIniFileEx.CreateExpand(FileName:TFileName);
begin
  inherited Create(ExpandPath(FileName));
end;

////////////////////////////////////////////////////////////////////////////////

procedure TMemIniFileEx.SetValue(const Ident,Value:String);
begin WriteStringS(Ident,Value);end;

function TMemIniFileEx.GetValue(const Ident:String): String;
begin Result := ReadStringS(Ident);end;

function TMemIniFileEx.GetValueCount(const Section:String): Integer;
var Ss:TStringList;
begin
  Ss := TStringList.Create;
  try
    if Section = '' then
      ReadSections(Ss)
    else
      ReadSection(Section,Ss);
    Result := Ss.Count;
  finally
    Ss.Free;
  end;
end;

procedure TMemIniFileEx.SetSectionText(const Section,Value: String);
var Ss:TStringList;
begin
  Ss := TStringList.Create;
  try
    Ss.Text := Value;
    WriteLines(Section,Ss,true);
  finally
    Ss.Free;
  end;
end;

function TMemIniFileEx.GetSectionText(const Section: String): String;
var Ss:TStringList;
begin
  Ss := TStringList.Create;
  try
    ReadLines(Section,Ss);
    Result := Ss.Text;
  finally
    Ss.Free;
  end;
end;

////// V[gANZXp\bh
procedure TMemIniFileEx.WriteStringS      (const Ident,Value:String);
begin WriteString(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadStringS       (const Ident:String;Default:String=''):String;
begin Result := ReadString(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WriteIntegerS     (const Ident:String;Value:Integer);
begin WriteInteger(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadIntegerS      (const Ident:String;Default:Integer=0):Integer;
begin Result := ReadInteger(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WriteBoolS        (const Ident:String;Value:Boolean);
begin WriteBool(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadBoolS         (const Ident:String;Default:Boolean=false):Boolean;
begin Result := ReadBool(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WriteDateTimeS    (const Ident:String;Value:TDateTime);
begin WriteDateTime(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadDateTimeS     (const Ident:String;Default:TDateTime=0):TDateTime;
begin Result := ReadDateTime(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WriteFloatS       (const Ident:String;Value:Double);
begin WriteFloat(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadFloatS        (const Ident:String;Default:Double=0):Double;
begin Result := ReadFloat(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WritePathS        (const Ident:String;Value:TFileName);
begin WritePath(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadPathS         (const Ident:String;Default:TFileName=''):TFileName;
begin Result := ReadPath(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WritePathRelativeS(const Ident:String;Value:TFileName);
begin WritePathRelative(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadPathRelativeS (const Ident:String;Default:TFileName=''):TFileName;
begin Result := ReadPathRelative(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WritePointS       (const Ident:String;Value:TPoint);
begin WritePoint(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadPointS        (const Ident:String;Default:TPoint):TPoint;
begin Result := ReadPoint(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WriteRectS        (const Ident:String;Value:TRect);
begin WriteRect(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadRectS         (const Ident:String;Default:TRect):TRect;
begin Result := ReadRect(mSection,Ident,Default); end;
//
procedure TMemIniFileEx.WriteFontS        (const Ident:String;Value:TFont);
begin WriteFont(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadFontS         (const Ident:String;Value:TFont):Boolean;
begin Result := ReadFont(mSection,Ident,Value); end;
//
procedure TMemIniFileEx.WriteColorS       (const Ident: String;Value: TColor);
begin WriteColor(mSection,Ident,Value); end;
function  TMemIniFileEx.ReadColorS        (const Ident: String;Default:TColor=clNone): TColor;
begin Result := ReadColor(mSection,Ident,Default); end;
//
////// ǉ\bh
// ϐpXۑ
procedure TMemIniFileEx.WritePath(const Section, Ident:String;const Value: TFileName);
begin
  WriteString(Section,Ident,ExtractPath(Value));
end;

function TMemIniFileEx.ReadPath(const Section, Ident:String;const Default: TFileName): TFileName;
begin
  Result  := ExpandPath(ReadString(Section,Ident,Default));
end;

// AppPathƂāA΃pXŕۑ
procedure TMemIniFileEx.WritePathRelative(const Section, Ident:String;const Value: TFileName);
begin
  WriteString(Section,Ident,ExtractRelativePath(appdir + PathDelim,Value));
end;

function TMemIniFileEx.ReadPathRelative(const Section, Ident:String;const Default: TFileName): TFileName;
var curdir:String;
begin
  Result  := ReadString(Section,Ident,Default);
  curdir  := GetCurrentDir;
  SetCurrentDir(appdir);
  Result  := ExpandFileName(Result);
  SetCurrentDir(curdir);
end;

// Point̒lۑ
procedure TMemIniFileEx.WritePoint(const Section, Ident:String;const Value: TPoint);
begin
  with Value do
    WriteString(Section,Ident,Format('%d,%d',[X,Y]));
end;

function TMemIniFileEx.ReadPoint(const Section, Ident:String;const Default: TPoint): TPoint;
var s: String;
begin
  // Xy[X؂Ől擾
  s       := ReadString(Section,Ident,'');
  Result.X:= StrToIntDef(PickToken(s, ','), Default.X);
  Result.Y:= StrToIntDef(s, Default.Y);
end;

// Rect̒lۑ
procedure TMemIniFileEx.WriteRect(const Section, Ident:String;const Value: TRect);
begin
  with Value do
    WriteString(Section,Ident,Format('%d,%d,%d,%d',[Top,Left,Bottom,Right]));
end;

function TMemIniFileEx.ReadRect(const Section, Ident:String;const Default: TRect): TRect;
var s: String;
begin
  // Xy[X؂Ől擾
  s             := ReadString(Section,Ident,'');
  Result.Top    := StrToIntDef(PickToken(s, ','), Default.Top);
  Result.Left   := StrToIntDef(PickToken(s, ','), Default.Left);
  Result.Bottom := StrToIntDef(PickToken(s, ','), Default.Bottom);
  Result.Right  := StrToIntDef(s , Default.Right);
end;

// Font̒lۑ
procedure TMemIniFileEx.WriteFont(const Section, Ident:String;const Value: TFont);
begin
  with Value do
    WriteString(Section,Ident,Format('%d,%d,%s,%d,%s',[Charset,Color,Name,Size,GetSetProp(Value,'Style',true)]));
end;

function TMemIniFileEx.ReadFont(const Section, Ident:String;var Value: TFont): Boolean;
var s: String;
begin
  // Xy[X؂Ńf[^擾
  Result        := false;
  s             := ReadString(Section,Ident,'');
  if not ValueExists(Section,Ident) then exit;
  Value.Charset := StrToIntDef(PickToken(s, ','),0);
  Value.Color   := StrToIntDef(PickToken(s, ','),clBlack);
  Value.Name    := PickToken(s, ',');
  Value.Size    := StrToIntDef(PickToken(s, ','),0);
  SetSetProp(Value,'Style', s);
  Result        := True;
end;

// ZNVۑAǂݍ
procedure TMemIniFileEx.WriteLines(const Section:String;Strings:TStrings;Saveline:Boolean=false);
var
  str : TStringList;
  i   : Integer;
begin
  str := TStringList.Create; try
  EraseSection(Section);
  // Init@Cǂݍ
  GetStrings(str);
  // VɃZNVǉ
  str.Add(Format('[%s]',[Section]));
  if Saveline then begin
    for i := 0 to Strings.Count - 1 do
      if Strings[i] = '' then
        str.Add('%s%')
      else
        str.Add(Strings[i]);
  end else
    str.AddStrings(Strings);
  str.Add('');
  // Init@C
  SetStrings(str);
  finally str.Free; end;
end;

function TMemIniFileEx.ReadLines(const Section:String;Strings:TStrings): Boolean;
var i : Integer;
begin
  Result        := false;
  if not SectionExists(Section) then exit;
  ReadSectionValues(Section,Strings);
  for i := 0 to Strings.Count - 1 do
    if Strings[i] = '%s%' then Strings[i] := '';
  Result        := true;
end;

// TColor ̒lۑ
procedure TMemIniFileEx.WriteColor(const Section, Ident: String; const Value: TColor);
begin WriteString(Section, Ident, ColorToString(Value)); end;

function TMemIniFileEx.ReadColor(const Section, Ident: String; Default: TColor): TColor;
begin
  if ValueExists(Section, Ident) then
    Result := StringToColor(ReadString(Section, Ident, ''))
  else
    Result := Default;
end;

////////////////////////////////////////////////////////////////////////////////

initialization
  appdir := ExtractFileDir(Application.ExeName);
  GetPaths;
finalization
  PathList.Free;
end.

