unit stdGraphics;

{$MESSAGE 'OtBbN샆jbg Ver 1.6'}
{__$WARNINGS OFF}
interface
uses Windows,Classes,SysUtils,Graphics,Math,stdFiles;
  type TDrawDirection = (ddHorizontal,ddVartical);
  type TDrawOblique   = (doObliqueLtR,doObliqueRtL);

  function  LightScreen(const Rect:TRect;Canvas:TCanvas;const lightCount:Integer): Cardinal;
  procedure Line(Canvas:TCanvas;const Color:TColor;const x1,y1,x2,y2:Integer;const Width:Integer=1);
  function  DrawTextShadow(Rect:TRect;Canvas:TCanvas;const Text:PChar;const Flags:Cardinal;
    const ShadowX,ShadowY:Integer;const FrontColor,ShadowColor:TColor): Cardinal;
  function  TileBitmap(const Rect:TRect;Canvas:TCanvas;Bitmap:TBitmap): Cardinal;

  function  DrawGradation(const Rect:TRect;Canvas:TCanvas;const DrawDirection:TDrawDirection;const Colors:array of TColor): Cardinal; overload;
  function  DrawGradation(const Rect:TRect;Canvas:TCanvas;const DrawDirection:TDrawOblique;const Color1,Color2:TColor): Cardinal; overload;
  function  DrawGradation(const Rect:TRect;Canvas:TCanvas;
    const LeftTop,RightTop,LeftBottom,RightBottom:TColor): Cardinal; overload;

  function  InValue(const aValue:Integer;const aMin: Integer=0;aMax:Integer=255;Looped:Boolean=false): Integer;
  procedure DivideRGB(const Color:TColor;var r,g,b:Byte);
  function  GetPixelForByteSize(PixelFormat:TPixelformat):Integer;
implementation
/////////////////////////
// @ꂫ@
/////////////////////////
// 1.0...LightScreen,GetPixelForByteSize,InValue֐ǉ
// 1.1...Line,DrawTextShadow֐ǉ
// 1.2...InValue֐Ɉǉ
// 1.3...DrawGradation,DivideRGB֐ǉ
// 1.4...DrawGradation֐gALightScreen,Line,DrawTextShadow֐`掞ԂԂ悤ɂB
// 1.5...InValueLooped=trueɖ[vɂȂ邱Ƃ̂C()
// 1.6...DrawGradation֐VXeJ[ɑΉ

uses Types;

function LightScreen(const Rect:TRect;Canvas:TCanvas;const lightCount:Integer): Cardinal;
  //------------------------------------------------------------------------------
  // LoX̖邳ύX
  // Rectc邭lp`̈
  // CanvascLoX
  // lightCountcPxA邢ق+
  // ߂lc`ɂ
  //------------------------------------------------------------------------------
var
  x,y,s   : Integer;
  P       : PByteArray;
  bmp     : TBitmap;
  rc      : TRect;
  ms      : Cardinal;
begin
  ms                := GetTickCount;
  //// rbg}bvɃRs[
  bmp               := TBitmap.Create;
  with Rect do begin
    // TCYAsNZݒ
    bmp.Width       := Right - Left;
    bmp.Height      := Bottom - Top;
    bmp.PixelFormat := pf24bit;
    s               := GetPixelForByteSize(pf24bit);
    // Rs[
    rc              := Bounds(0,0,bmp.Width,bmp.Height);
    bmp.Canvas.CopyRect(rc,Canvas,Rect);
    try
      for y         := 0 to bmp.Height - 1 do begin
        P           := bmp.ScanLine[y];
        for x       := 0 to (bmp.Width * s) - 1 do
          P[x]      := InValue(P[x] + lightCount);
      end;
      // Rs[ďI
      Canvas.CopyRect(Rect,bmp.Canvas,rc);
    finally
      bmp.Free;
    end;
  end;
  Result            := GetTickCount - ms;
end;

procedure Line(Canvas:TCanvas;const Color:TColor;const x1,y1,x2,y2:Integer;const Width:Integer=1);
  //------------------------------------------------------------------------------
  // 
  // CanvascLoX
  // Colorc̐F
  // x1cJnXʒu
  // y1cJnYʒu
  // x2cIXʒu
  // y2cIYʒu
  // Widthc̑
  //------------------------------------------------------------------------------
begin
  if Canvas.Pen.Color <> Color then
    Canvas.Pen.Color  := Color;
  if Canvas.Pen.Width <> Width then
    Canvas.Pen.Width  := Width;
  Canvas.MoveTo(x1,y1);
  Canvas.LineTo(x2,y2);
end;

function DrawTextShadow(Rect:TRect;Canvas:TCanvas;const Text:PChar;const Flags:Cardinal;
  const ShadowX,ShadowY:Integer;const FrontColor,ShadowColor:TColor): Cardinal;
  //------------------------------------------------------------------------------
  // êeLXg`
  // Rectc`̈
  // CanvascLoX
  // Textc`悷eLXg
  // FlagscDrawTextAPIɓntOADT_??萔
  // ShadowXcẽeLXǵA\ʃeLXgXΈʒu
  // ShadowYcẽeLXǵA\ʃeLXgYΈʒu
  // FrontColorc\ʃeLXg̐F
  // ShadowColorceeLXg̐F
  // Resultc`ɂ
  // `ALoX̃tHgJ[́AFrontColorɂȂ
  //------------------------------------------------------------------------------
var
  ms:Cardinal;
  rc:TRect;
begin
  ms := GetTickCount;
  SetBkMode(Canvas.Handle,TRANSPARENT);
  // e`悷
  rc := Rect;
  OffsetRect(rc,ShadowX,ShadowY);
  Canvas.Font.Color := ShadowColor;
  DrawText(Canvas.Handle,Text,-1,rc,Flags);
  // \ʂ`悷
  Canvas.Font.Color := FrontColor;
  DrawText(Canvas.Handle,Text,-1,Rect,Flags);
  Result            := GetTickCount - ms;
end;

function  TileBitmap(const Rect:TRect;Canvas:TCanvas;Bitmap:TBitmap): Cardinal;
  //------------------------------------------------------------------------------
  // rbg}bv^Cɒt
  // Rectc`̈
  // CanvascLoX
  // Bitmapcrbg}bv
  // Resultc`ɂ
  //------------------------------------------------------------------------------
var
  bmp : TBitmap;
  i,j : Integer;
  ms  : Cardinal;
begin
  if Bitmap.Empty then exit;
  ms  := GetTickCount;
  bmp := TBitmap.Create;
  try
    // rbg}bvTCYw
    with Rect do begin
      bmp.Width := Right - Left;
      bmp.Height:= Bottom- Top;
    end;
    i   := 0;
    while i <= bmp.Width do begin // ̂Ԃ񃋁[v
      j := 0;
      while j <= bmp.Height do begin // ĉԂ񃋁[v
        bmp.Canvas.Draw(i,j,Bitmap);
        inc(j,Bitmap.Height);
      end;
      inc(i,Bitmap.Width);
    end;
    // `
    with Rect do
      Canvas.CopyRect(Rect,bmp.Canvas,classes.Rect(0,0,bmp.Width,bmp.Height));
  finally
    bmp.Free;
  end;
  Result := GetTickCount - ms;
end;

function DrawGradation(const Rect:TRect;Canvas:TCanvas;const DrawDirection:TDrawDirection;const Colors:array of TColor): Cardinal;
  //------------------------------------------------------------------------------
  // Of[V`
  // Rectc`悷lp`
  // CanvascLoX
  // DrawGradationcOf[V
  // ColorscF̔z
  // Resultc`ɂ~b
  //------------------------------------------------------------------------------
  procedure Gradient(Canvas:TCanvas;Rect:TRect;Color1,Color2:TColor);
    //------------------------------------------------------------------------------
    // Of[V
    // Canvasc`悷LoX
    // Rectc`̈
    // Color1cJnF
    // Color2cIF
    //------------------------------------------------------------------------------
  var
    i       : Integer;
    rgb     : array[0..1] of array[0..2] of byte;
    oncergb : array[0..2] of Currency;
    //////
    procedure GetOnce(range:Integer);
      // 񂠂̑l擾 rangec
    var e: Integer;
    begin
      for e := 0 to 2 do
        oncergb[e] := (rgb[0,e] - rgb[1,e]) / (range - 1);
    end;
    //////
    function GetLineColor(MinusPoint:Integer):TColor;
      // ̐F߂ MinusPointcO[vl猸Zl
    var
      e     : Integer;
      PointC: array[0..2] of TColor;
    begin
      for e := 0 to 2 do
        PointC[e] := rgb[1,e] + Trunc(oncergb[e] * (i - MinusPoint));
      Result := windows.RGB(PointC[0],PointC[1],PointC[2]);
    end;
    //////
  begin
    // JnFIFzɎd
    DivideRGB(ColorToRGB(Color2),rgb[0,0],rgb[0,1],rgb[0,2]);
    DivideRGB(ColorToRGB(Color1),rgb[1,0],rgb[1,1],rgb[1,2]);
    with Rect do begin
      case DrawDirection of
        ddHorizontal:begin
          GetOnce(Right - Left);
          for i := Left to Right - 1 do
            Line(Canvas,GetLineColor(Left),i,Top,i,Bottom);
        end;
        ddVartical:begin
          GetOnce(Bottom - Top);
          for i := Top to Bottom - 1 do
            Line(Canvas,GetLineColor(Top),Left,i,Right,i);
        end;
      end;
    end;
  end;
label goexit;
var
  ms    : Cardinal;
  span,spanpix,
    i   : Integer;
  rc    : TRect;
  //////
  procedure OffsetRectSpan(Offset:Boolean);
    // rcspanpixԂ񂸂炷AOffsetFalseȂA
    // [炷
  begin
    case DrawDirection of
      ddHorizontal:
        if Offset then
          OffsetRect(rc,spanpix,0)
        else
          rc.Right  := spanpix;
      ddVartical  :
        if Offset then
          OffsetRect(rc,0,spanpix)
        else
          rc.Bottom := spanpix;
    end;
  end;
  //////
begin
  ms              := GetTickCount;
  case Length(Colors) of
    1:begin// z1̏ꍇAhԂs
      Canvas.Brush.Color := Colors[Low(Colors)];
      Canvas.FillRect(Rect);
      goto goexit;
    end;
    2:begin// Ԑߖ̂߁A֐ĂёXɔ
      Gradient(Canvas,Rect,Colors[Low(Colors)],Colors[Low(Colors) + 1]);
      goto goexit;
    end;
  end;
  // vZ
  rc              := Rect;
  span            := High(Colors);
  with Rect do begin
    case DrawDirection of
      ddHorizontal:
        spanpix   := (Right - Left) div span;
      ddVartical  :
        spanpix   := (Bottom - Top) div span;
    end;
  end;
  // `揀
  rc              := Rect;
  OffsetRectSpan(false);
  for i           := 0 to span - 1 do begin
    Gradient(Canvas,rc,Colors[i],Colors[i + 1]);
    // Rect炷
    OffsetRectSpan(true);
  end;

goexit:
  Result    := GetTickCount - ms;
end;

function  DrawGradation(const Rect:TRect;Canvas:TCanvas;const DrawDirection:TDrawOblique;const Color1,Color2:TColor): Cardinal;
  //------------------------------------------------------------------------------
  // Of[V`
  // Rectc`悷lp`
  // CanvascLoX
  // DrawGradationcOf[V
  // Color1cJnF
  // Color2cIF
  // Resultc`ɂ~b
  //------------------------------------------------------------------------------
var
  i       : Integer;
  rgb     : array[0..1] of array[0..2] of byte;
  oncergb : array[0..2] of Currency;
  ms      : Cardinal;
  //////
  function GetLineColor(MinusPoint:Integer):TColor;
    // ̐F߂ MinusPointcO[vl猸Zl
  var
    e     : Integer;
    PointC: array[0..2] of TColor;
  begin
    for e := 0 to 2 do
      PointC[e] := rgb[1,e] + Trunc(oncergb[e] * (i - MinusPoint));
    Result := windows.RGB(PointC[0],PointC[1],PointC[2]);
  end;
  //////
begin
  ms              := GetTickCount;
  // JnFIFzɎd
  DivideRGB(ColorToRGB(Color2),rgb[0,0],rgb[0,1],rgb[0,2]);
  DivideRGB(ColorToRGB(Color1),rgb[1,0],rgb[1,1],rgb[1,2]);
  //@񂠂̑l擾
  with Rect do begin
    for i := 0 to 2 do
      oncergb[i] := (rgb[0,i] - rgb[1,i]) / ((Right - Left) + (Bottom - Top) - 1);
    case DrawDirection of // Of[V
      doObliqueLtR:
        for i := Left + Top to Right + Bottom - 1 do
          Line(Canvas,GetLineColor(Left + Top),Left,i,i,Top);
      doObliqueRtL:
        for i := Left + Top to Right + Bottom - 1 do
          Line(Canvas,GetLineColor(Left + Top),(Left + Right) - i,Top,Right,i);
    end;
  end;
  Result    := GetTickCount - ms;
end;

function  DrawGradation(const Rect:TRect;Canvas:TCanvas;
  const LeftTop,RightTop,LeftBottom,RightBottom:TColor): Cardinal; overload;
  //------------------------------------------------------------------------------
  // Of[V`
  // Rectc`悷lp`
  // CanvascLoX
  // LeftTopc̐F
  // RightTopcE̐F
  // LeftBottomc̐F
  // RightBottomcE̐F
  // Resultc`ɂ~b
  //------------------------------------------------------------------------------
var
  i,e,j   : Integer;
  rgb     : array[0..3] of array[0..2] of byte;
  oncergb : array[0..1] of array[0..2] of Currency;
  PointC  : array[0..2] of Byte;
  ms,width,height: Cardinal;
begin
  ms              := GetTickCount;
  with Rect do begin
    width         := Right - Left;
    height        := Bottom - Top;
  end;
  // JnFIFzɎd
  DivideRGB(ColorToRGB(RightTop),rgb[0,0],rgb[0,1],rgb[0,2]);
  DivideRGB(ColorToRGB(LeftTop),rgb[1,0],rgb[1,1],rgb[1,2]);
  DivideRGB(ColorToRGB(RightBottom),rgb[2,0],rgb[2,1],rgb[2,2]);
  DivideRGB(ColorToRGB(LeftBottom),rgb[3,0],rgb[3,1],rgb[3,2]);
  for i:= 0 to Width - 1 do begin
    for e := 0 to 2 do begin // E̐F̌vZ
      oncergb[0,e] := rgb[1,e] * (1 - (i / width)) + rgb[0,e] * (i / width);
      oncergb[1,e] := rgb[3,e] * (1 - (i / width)) + rgb[2,e] * (i / width);
    end;
    for j:= 0 To height - 1 do begin
      for e := 0 to 2 do //㉺̐F̌vZyŒԂ̐F߂
        PointC[e] := Trunc(oncergb[0,e] * (1 - (j / height)) + oncergb[1,e] * (j / height));
      Canvas.Pixels[i,j] := windows.RGB(PointC[0],PointC[1],PointC[2]); // FZbg
    end;
  end;
  Result    := GetTickCount - ms;
end;

////

procedure DivideRGB(const Color:TColor;var r,g,b:Byte);
  //------------------------------------------------------------------------------
  // RGBl𕪊AgetRValueȂǂ荂炵
  // ColorcJ[l
  // r,g,bcꂼR,G,B̋Px
  //------------------------------------------------------------------------------
begin
  r:=(Color and $0000FF);
  g:=((Color shr 8) and $0000FF);
  b:=((Color shr 16) and $0000FF);
end;

////

function InValue(const aValue:Integer;const aMin: Integer=0;aMax:Integer=255;Looped:Boolean=false): Integer;
  //------------------------------------------------------------------------------
  // aValueAőlŏl̊Ԃɓ悤ɂ
  // aValuecl
  // aMincŏl
  // aMaxcől
  // LoopedctruȅꍇAaValuéAőlŏl̒l̊Ԃ[v悤ɂ
  //------------------------------------------------------------------------------
var val:Integer;
begin
  // aMinaMaxsȒl
  if aMin >= aMax then begin
    Result := aMin;
    exit;
  end;
  val := aValue;
  while not InRange(val,aMin,aMax) do begin
    if val > aMax then begin
      if Looped then
        Dec(val,aMax - aMin + 1)
      else
        val := aMax;
    end else if val < aMin then begin
      if Looped then
        Inc(val,aMax + aMin  + 1)
      else
        val := aMin;
    end;
  end;
  Result := val;
end;

function GetPixelForByteSize(PixelFormat:TPixelformat):Integer;
begin
  case PixelFormat of
    pf8bit  : Result := 1;
    pf16bit : Result := 2;
    pf24bit : Result := 3;
    pf32bit : Result := 4;
  end;
end;

end.
