unit stdRecords;

{$MESSAGE '\̍쐬ėp샆jbg Ver 1.2'}
interface
  uses RichEdit,Graphics,ComCtrls;
  function NewCharFormat(const Color:TColor=0;
    const Effects:TFontStyles=[];const FontSize:Cardinal=0;const Offset:Integer=0): TCharFormat;
  function NewCharRange(const StartPos,EndPos:Integer): TCharRange;
  function IntToFontStyle(const Value:Integer): TFontStyles;
  function FontStyleToInt(const Value:TFontStyles): Integer;
  function NewSearchType(const WordWhole,MatchCase:Boolean): TSearchTypes;
implementation
/////////////////////////
// @ꂫ@
/////////////////////////
// 1.0...NewCharFormat,NewCharRange֐ǉ
// 1.1...IntToFontStyle,FontStyleToInt֐ǉ
// 1.2...NewSearchType֐ǉ

function NewCharFormat(const Color:TColor=0;
  const Effects:TFontStyles=[];const FontSize:Cardinal=0;const Offset:Integer=0): TCharFormat;
var
  Masks,Effect  : Cardinal;
  CF            : TCharFormat;
begin
  with CF do begin
    Masks     := 0;
    cbSize    := SizeOf(CF);
    if (fsBold in Effects) then inc(Masks,CFM_BOLD);
    if (fsItalic in Effects) then inc(Masks,CFM_ITALIC);
    if (fsUnderline in Effects) then inc(Masks,CFM_UNDERLINE);
    if (fsStrikeout in Effects) then inc(Masks,CFM_STRIKEOUT);
    Effect := Masks;
    if Color <> 0 then begin
      inc(Masks,CFM_COLOR);
      crTextColor := Color;
    end;
    if FontSize <> 0 then begin
      inc(Masks,CFM_SIZE);
      yHeight  := FontSize * 20;
    end;
    if Offset <> 0 then begin
      inc(Masks,CFM_OFFSET);
      yOffset  := Offset;
    end;
    dwEffects := Effect;
    dwMask    := Masks;
  end;
  Result := CF;
end;

function NewCharRange(const StartPos,EndPos:Integer): TCharRange;
begin
  with Result do begin
    cpMin  := StartPos;
    cpMax  := EndPos;
  end;
end;

function IntToFontStyle(const Value:Integer): TFontStyles;
var
  FS    : Byte;
  Font  : TFontStyles absolute FS;
begin
  FS    := Value;
  Result:= Font;
end;

function FontstyleToInt(const Value:TFontStyles): Integer;
var
  Font  : TFontStyles;
  FS    : Byte absolute Font;
begin
  Font  := Value;
  Result:= FS;
end;

function NewSearchType(const WordWhole,MatchCase:Boolean): TSearchTypes;
var i : TSearchTypes;
begin
  i := [];
  if WordWhole then
    i := i + [stWholeWord];
  if MatchCase then
    i := i + [stMatchCase];
  Result := i;
end;
end.
