unit ConfigDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, StdCtrls, ComCtrls, Contnrs, Math,
  // T[hp[eB[̊gR|[lg
  // Ց̊gjbg
  stdVCLCtrl, stdGraphics, stdRecords, StrToken,
  // Ց̊gR|[lg
  ExIniFiles,
  // vWFNg̃jbg
  CalendarDrawer
;

type
  TTCalendarSettingDialog = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    PageControl: TPageControl;
    ColorMap: TTabSheet;
    FontSet: TGroupBox;
    FontName: TComboBox;
    FontSize: TEdit;
    FontSizeUpDown: TUpDown;
    TabSheet2: TTabSheet;
    Label4: TLabel;
    StartOfWeek: TComboBox;
    SpecialDaysBox: TGroupBox;
    TabSheet3: TTabSheet;
    GroupBox2: TGroupBox;
    StyleLists: TListBox;
    Bold: TCheckBox;
    Italic: TCheckBox;
    UnderLine: TCheckBox;
    Label2: TLabel;
    ForeColor: TColorBox;
    Label3: TLabel;
    ShadowColor: TColorBox;
    StartColor: TColorBox;
    FinishColor: TColorBox;
    Label1: TLabel;
    Label8: TLabel;
    SpecialDays: TListBox;
    SDType: TComboBox;
    SDMonth: TLabeledEdit;
    SDMonthUpDown: TUpDown;
    SDDay: TLabeledEdit;
    SDDayUpDown: TUpDown;
    SDWeekIndex: TLabeledEdit;
    SDWeekIndexUpDown: TUpDown;
    SDWeekName: TComboBox;
    SDAdd: TButton;
    SDDelete: TButton;
    GroupBox1: TGroupBox;
    LockKey: TRadioGroup;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    TransparencyOfTransparentMode: TScrollBar;
    TransparencyOfLockMode: TScrollBar;
    ShowTopMost: TCheckBox;
    Label5: TLabel;
    TodayCursor: TComboBox;
    CursorColor: TColorBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StyleListsDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure StyleListsClick(Sender: TObject);
    procedure FontStylesUpdate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TransparencyCheckEnter(Sender: TObject);
    procedure TransparencyCheckExit(Sender: TObject);
    procedure TransparencyCheckScroll(Sender: TObject;
      ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure FontNameClick(Sender: TObject);
    procedure FontSizeChange(Sender: TObject);
    procedure SpecialDaysClick(Sender: TObject);
    procedure SDAddClick(Sender: TObject);
    procedure SDDeleteClick(Sender: TObject);
    procedure SDTypeChange(Sender: TObject);
    procedure SDItemsChanged(Sender: TObject);
    procedure TodayCursorClick(Sender: TObject);
    procedure CursorColorClick(Sender: TObject);
  private
    { Private 錾 }
    List    : TObjectList;
    Loading : Boolean;
    procedure EnabledChange(Enabled: Boolean; Tag: Integer = 0);
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public 錾 }
  end;

var
  TCalendarSettingDialog: TTCalendarSettingDialog;

const
  WStr : array[0..7] of String = (
    'Colors.Year', 'Colors.Month',
    'Colors.Weekday', 'Colors.Sunday',
    'Colors.Saturday', 'Colors.Holyday',
    'Colors.Specialday', 'Colors.Today');
  WeekChars = 'smtwhfa';

implementation

uses IniFiles, Main, StrUtils;

{$R *.dfm}

/// tH[̐
procedure TTCalendarSettingDialog.FormCreate(Sender: TObject);
begin
  PageControl.ActivePage := ColorMap;
  Loading := true;
  ShowConfig := true;
  FontName.Items.Assign(Screen.Fonts);
  List := TObjectList.Create;
  List.Add(TCalendarColor.Create(clLime, clGray));
  List.Add(TCalendarColor.Create(clCream, clOlive));
  List.Add(TCalendarColor.Create(clBlack, clWhite));
  List.Add(TCalendarColor.Create(clRed, clMaroon));
  List.Add(TCalendarColor.Create(clBlue, clNavy));
  List.Add(TCalendarColor.Create(clFuchsia, clPurple, [fsItalic]));
  List.Add(TCalendarColor.Create(clWhite, clBlack, [fsBold]));
  List.Add(TCalendarColor.Create(clLime, clSilver, [fsUnderline]));
  StyleLists.ItemIndex := 0;
  TCalendarDisplayForm.AlphaBlendValue := 255;
  StyleLists.OnClick(nil);
end;

procedure TTCalendarSettingDialog.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := TCalendarDisplayForm.Handle;
end;

/// tH[̔j
procedure TTCalendarSettingDialog.FormDestroy(Sender: TObject);
begin
  ShowConfig  := false;
  List.Free;
end;

////

/// X^C̃XgI[i[h[
procedure TTCalendarSettingDialog.StyleListsDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
const
  Flags : Integer = DT_VCENTER or DT_SINGLELINE or DT_NOCLIP or DT_NOPREFIX;
begin
  with TCalendarColor(List[Index]) do begin
    // wi
    StyleLists.Canvas.FillRect(Rect);
    StyleLists.Canvas.Font.Style := FontStyle;
    // `
    if ShadowColor = clNone then
    begin
      StyleLists.Canvas.Font.Color := Color;
      DrawText(StyleLists.Canvas.Handle,
        PChar(StyleLists.Items[Index]), -1, Rect, Flags)
    end else
      DrawTextShadow(Rect, StyleLists.Canvas,
        PChar(StyleLists.Items[Index]), Flags,
        ShadowPoint.X, ShadowPoint.Y, Color, ShadowColor);
  end;
end;

/// X^CXg̓eAҏWɃRs[
procedure TTCalendarSettingDialog.StyleListsClick(Sender: TObject);
begin
  with TCalendarColor(List[StyleLists.ItemIndex]) do begin
    Tag := 1;
    Bold.Checked      := fsBold in FontStyle;
    Italic.Checked    := fsItalic in FontStyle;
    UnderLine.Checked := fsUnderline in FontStyle;
    ForeColor.Selected:= Color;
    Self.ShadowColor.Selected
                      := ShadowColor;
    Tag := 0;
  end;
end;

procedure TTCalendarSettingDialog.FontStylesUpdate(Sender: TObject);
  // CfbNXYTCalendarColor𓾂
  function GetColorRecord(Index: Integer): TCalendarColor;
  begin
    Result := nil;
    with TCalendarDisplayForm.Drawer do begin
      case Index of
        0: Result := YearColor;
        1: Result := MonthColor;
        2: Result := WeekdayColor;
        3: Result := SundayColor;
        4: Result := SaturdayColor;
        5: Result := HolydayColor;
        6: Result := HighlightDayColor;
        7: Result := TodayColor;
      end;
    end;
  end;

var f: TFontStyles;
begin
  if Tag = 1 then exit;
  with TCalendarColor(List[StyleLists.ItemIndex]) do begin
    // TCalendarColor̍XV
    f := [];
    if Bold.Checked then Include(f, fsBold);
    if Italic.Checked then Include(f, fsItalic);
    if UnderLine.Checked then Include(f, fsUnderline);
    FontStyle         := f;
    Color             := ForeColor.Selected;
    ShadowColor       := Self.ShadowColor.Selected;
    StyleLists.Invalidate;
  end;
  // vr[̍XV
  with GetColorRecord(StyleLists.ItemIndex) do begin
    Color       := ForeColor.Selected;
    ShadowColor := Self.ShadowColor.Selected;
  end;
  TCalendarDisplayForm.CalendarUpdate;
end;

procedure TTCalendarSettingDialog.TodayCursorClick(Sender: TObject);
begin
  TMyDrawer(TCalendarDisplayForm.Drawer).TodayInCursor := TodayCursor.ItemIndex;
  TCalendarDisplayForm.CalendarUpdate;
end;

procedure TTCalendarSettingDialog.CursorColorClick(Sender: TObject);
begin
  TMyDrawer(TCalendarDisplayForm.Drawer).TodayCursorColor := CursorColor.Selected;
  TCalendarDisplayForm.CalendarUpdate;
end;

procedure TTCalendarSettingDialog.FormShow(Sender: TObject);
const
  clSalmon : TColor = $7280FA;
var i : Integer;
begin
  with TMemIniFileEx.CreateDef do begin try
    Section         := 'General';
    FontName.ItemIndex
                    :=
                    EnsureRange(
                      FontName.Items.IndexOf(ReadStringS('FontName', Font.Name)),
                      0, FontName.Items.Count - 1);
    FontSizeUpDown.Position
                    := ReadIntegerS('FontSize', Font.Size);
    StartOfWeek.ItemIndex
                    :=
                   EnsureRange(
                    ReadIntegerS('StartWeekDay'), 0, 7);
    LockKey.ItemIndex
                    := ReadIntegerS('LockKey');
    TodayCursor.ItemIndex
                    := ReadIntegerS('CircleInToday');
    CursorColor.Selected
                    := ReadColorS('CursorColor', clRed);
    ShowTopMost.Checked
                    := ReadBoolS('TopMost', True);
    Section         := 'BackColor';
    StartColor.Selected
                    := ReadColorS('StartColor', clSalmon);
    FinishColor.Selected
                    := ReadColorS('FinishColor', clYellow);
    Section         := 'Transparency';
    TransparencyOfTransparentMode.Position
                    := ReadIntegerS('NormalMode', 255);
    TransparencyOfLockMode.Position
                    := ReadIntegerS('LockMode', 255);
    for i := 0 to High(WStr) do begin
      Section       := WStr[i];
      with TCalendarColor(List[i]) do begin
        Color       := ReadColorS('Color', Color);
        ShadowColor := ReadColorS('ShadowColor', ShadowColor);
        FontStyle   := IntToFontStyle(ReadIntegerS('FontStyle', FontStyleToInt(FontStyle)));
      end;
    end;
    ReadLines('SpecialDays', SpecialDays.Items);
    OnShow := nil;
  finally
    Free;
    Loading := false;
  end;
  end;
end;

procedure TTCalendarSettingDialog.OKBtnClick(Sender: TObject);
var i : Integer;
begin
  with TMemIniFileEx.CreateDef do begin try
    Section := 'General';
    WriteStringS('FontName', FontName.Text);
    WriteIntegerS('FontSize', FontSizeUpDown.Position);
    WriteIntegerS('StartWeekDay', StartOfWeek.ItemIndex);
    WriteIntegerS('LockKey', LockKey.ItemIndex);
    WriteIntegerS('CircleInToday', TodayCursor.ItemIndex);
    WriteColorS('CursorColor', CursorColor.Selected);
    WriteBoolS('TopMost', ShowTopMost.Checked);
    Section := 'BackColor';
    WriteColorS('StartColor', StartColor.Selected);
    WriteColorS('FinishColor', FinishColor.Selected);
    Section := 'Transparency';
    WriteIntegerS('NormalMode', TransparencyOfTransparentMode.Position);
    WriteIntegerS('LockMode', TransparencyOfLockMode.Position);
    for i := 0 to High(WStr) do begin
      Section       := WStr[i];
      with TCalendarColor(List[i]) do begin
        WriteColorS('Color', Color);
        WriteColorS('ShadowColor', ShadowColor);
        WriteIntegerS('FontStyle', FontStyleToInt(FontStyle));
      end;
    end;
    WriteLines('SpecialDays', SpecialDays.Items);
    UpdateFile;
  finally
    Free;
  end;
  end;
end;

procedure TTCalendarSettingDialog.TransparencyCheckEnter(
  Sender: TObject);
begin
  TCalendarDisplayForm.AlphaBlendValue := TScrollBar(Sender).Position;
end;

procedure TTCalendarSettingDialog.TransparencyCheckExit(
  Sender: TObject);
begin
  TCalendarDisplayForm.AlphaBlendValue := 255;
end;

procedure TTCalendarSettingDialog.TransparencyCheckScroll(
  Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  TCalendarDisplayForm.AlphaBlendValue := ScrollPos;
end;

procedure TTCalendarSettingDialog.FontNameClick(Sender: TObject);
begin
  TCalendarDisplayForm.Drawer.Font.Name := FontName.Text;
  TCalendarDisplayForm.CalendarUpdate;
  if CanFocus then SetFocus;
  if FontName.CanFocus then FontName.SetFocus;
end;

procedure TTCalendarSettingDialog.FontSizeChange(Sender: TObject);
begin
  TCalendarDisplayForm.Drawer.Font.Size := FontSizeUpDown.Position;
  TCalendarDisplayForm.CalendarUpdate;
end;

procedure TTCalendarSettingDialog.SpecialDaysClick(Sender: TObject);
var dayname : String;
begin
  Loading := True;
  try
    if SpecialDays.ItemIndex = -1 then
      EnabledChange(false, 0)
    else begin
      // I𒆃ACe̕
      dayname := GetListCurrent(SpecialDays);
      SDMonthUpDown.Position := StrToIntDef(PickToken(dayname, '/'), 1);
      if (Length(dayname) >= 3) and (dayname[1] = 'w') then begin
        SDType.ItemIndex := 1;
        // jw
        SDWeekName.ItemIndex := Pos(dayname[3], WeekChars) - 1;
        SDWeekIndexUpDown.Position :=  StrToIntDef(dayname[2], 1);
      end else begin
        SDType.ItemIndex := 0;
        SDDayUpDown.Position := StrToIntDef(dayname, 1);
      end;
      SDTypeChange(Sender);
      EnabledChange(True, 1);
    end;
  finally
    Loading := False;
  end;
end;

procedure TTCalendarSettingDialog.SDAddClick(Sender: TObject);
begin
  SpecialDays.AddItem('1/1', nil);
end;

procedure TTCalendarSettingDialog.SDDeleteClick(Sender: TObject);
begin
  SpecialDays.DeleteSelected;
  EnabledChange(false);
end;

procedure TTCalendarSettingDialog.SDTypeChange(Sender: TObject);
begin
  // UpDownRg[̃Cl[uJ
  if  SDType.ItemIndex = 0 then begin
    EnabledChange(True, 2);
    EnabledChange(False, 3);
  end else begin
    EnabledChange(True, 3);
    EnabledChange(False, 2);
  end;
end;

procedure TTCalendarSettingDialog.SDItemsChanged(Sender: TObject);

begin
  if Loading or (SpecialDays.ItemIndex = -1) then exit;
  // I𒆃ACe̍XV
  SpecialDays.Items[SpecialDays.ItemIndex] := IfThen(SDType.ItemIndex = 0,
      Format('%d/%d', [SDMonthUpDown.Position, SDDayUpDown.Position]),
      Format('%d/w%d%s', [SDMonthUpDown.Position, SDWeekIndexUpDown.Position,
        WeekChars[SDWeekName.ItemIndex + 1]]));
end;


/// wRg[̃Cl[uJ(Tag0̏ꍇ1ȏシׂāAȊOTag̐lvꍇ̂)
procedure TTCalendarSettingDialog.EnabledChange(Enabled: Boolean;
    Tag: Integer);
var
  i     : Integer;
  myTag : Integer;
begin
  for i := 0 to SpecialDaysBox.ControlCount - 1 do begin
    myTag := TControl(SpecialDaysBox.Controls[i]).Tag;
    if ((Tag <> 0) and (myTag = Tag)) or ((Tag = 0) and (myTag > 0)) then
      TControl(SpecialDaysBox.Controls[i]).Enabled := Enabled;
  end;
end;

end.


