unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StrUtils, AppEvnts, ExtCtrls, Menus, DateUtils,
  // T[hp[eB[̊gR|[lg
  Taskbar,
  // Ց̊gjbg
  stdGraphics, stdDialogs, stdInt, stdRecords, StrToken,
  // Ց̊gR|[lg
  SizeBox, ExIniFiles, StdCtrls,
  // vWFNg̃jbg
  CalendarDrawer
  ;

// tbNDLL֐̃C|[g

function SetHookProcedure(Owner: HWND): Boolean;
    stdcall; external'TCalHook.dll';
function UnSetHookProcedure(): Boolean;
    stdcall; external'TCalHook.dll';

const
  HM_KEYBOARDACTION = WM_APP + $100;
  HM_KEYHOOKDONE    = WM_APP + $101;


type
  TTCalendarDisplayForm = class(TForm)
    PopupMenu: TPopupMenu;
    AppExit: TMenuItem;
    N1: TMenuItem;
    Timer: TTimer;
    HideForm: TMenuItem;
    ShowNextMonth: TMenuItem;
    ShowPrevMonth: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure AppExitClick(Sender: TObject);
    procedure ConfigClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure HideFormClick(Sender: TObject);
    procedure ShowChangeMonth(Sender: TObject);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  private
    { Private 錾 }
    SPDay       : TStringList;
    NormalAlpha : Byte;
    LockAlpha   : Byte;
    LockKey     : Integer;
    StartColor  : TColor;
    FinishColor : TColor;
    TrayIcon    : TTrayIcon;
    SizeBox     : TSizeBox;
    procedure ShiftKeyKeyUp();
    procedure ShiftKeyKeyDown();
    procedure ChangeMonth(Changes: Integer);
  protected
    { Protected 錾 }
    procedure HMKeyhookdone(var Message: TMessage); message HM_KEYHOOKDONE;
    procedure HMKeyboardaction(var Message: TMessage); message HM_KEYBOARDACTION;
    procedure ReloadSettings();
    procedure CreateWnd; override;
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public 錾 }
    Drawer        : TCalendarDrawer;
    ShowingYear   : Integer;
    ShowingMonth  : Integer;
    procedure CalendarUpdate;
    procedure CalendarSetDates(Year, Month: Word);
    function CreateSpecialDayList(): TDays;
  end;

  TMyDrawer = class(TCalendarDrawer)
  private
    { Private 錾 }
    mTodayInCursor: Integer;
    mTodayCursorColor: TColor;
    procedure SetTodayCursorColor(const Value: TColor);
    procedure SetTodayInCursor(const Value: Integer);
  protected
    procedure DoDrawDay(Canvas: TCanvas; Rect: TRect; ADate: TDate;
      DateElement: TDateElements); override;
  public
    { Public 錾 }
    property TodayInCursor: Integer read  mTodayInCursor  write SetTodayInCursor;
    property TodayCursorColor: TColor read  mTodayCursorColor write SetTodayCursorColor;
  end;


var
  TCalendarDisplayForm: TTCalendarDisplayForm;
  ShiftKeyPressed     : Boolean;
  ShowConfig            : Boolean;

implementation

uses Types, Math, ConfigDlg, IniFiles;

{$R *.dfm}

procedure TTCalendarDisplayForm.FormCreate(Sender: TObject);
var
  p : TPoint;
begin
  try
    // 
    TrayIcon          := TTrayIcon.Create(Self);
    TrayIcon.TipHelp  := Application.Title;
    TrayIcon.Icon     := Application.Icon;
    TrayIcon.RButtonPopupMenu := PopupMenu;
    TrayIcon.OnDblClick       := HideFormClick;
    SizeBox           := TSizeBox.Create(Self);
    SizeBox.Parent    := Self;
    SizeBox.Align     := alClient;
    SPDay             := TStringList.Create;
    if not SetHookProcedure(Handle) then raise Exception.Create('tbNɎs܂B');

    ShowingYear       := YearOf(Now);
    ShowingMonth      := MonthOf(Now);
    Drawer := TMyDrawer.Create;
    with TMemIniFileEx.CreateDef do begin try
      Section := 'General';
      p       := ReadPointS('Location', BoundsRect.TopLeft);
      Top     := p.Y;
      Left    := p.X;
    finally
      Free;
    end;
    end;
    ReloadSettings;
  except
    Halt;
  end;
end;

procedure TTCalendarDisplayForm.CreateWnd;
begin
  inherited;
end;

/// c[EBhEX^Ct
procedure TTCalendarDisplayForm.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Inc(Params.ExStyle, WS_EX_TOOLWINDOW);
end;

procedure TTCalendarDisplayForm.FormDestroy(Sender: TObject);
begin
  with TMemIniFileEx.CreateDef do begin try
    Section := 'General';
    WritePointS('Location', BoundsRect.TopLeft);
    UpdateFile;
  finally
    Free;
  end;
  end;
  UnSetHookProcedure;
  SPDay.Free;
  Drawer.Free;
  TrayIcon.Free;
//  SizeBox.Free;
end;

/// V[gJbgL[̓
procedure TTCalendarDisplayForm.FormShortCut(var Msg: TWMKey;
  var Handled: Boolean);
begin
  case Msg.CharCode of
    VK_LEFT:
      ShowPrevMonth.Click;
    VK_RIGHT:
      ShowNextMonth.Click;
    VK_UP:
      ChangeMonth(12);
    VK_DOWN:
      ChangeMonth(-12);
  end;
  Handled := True;
end;

/// }EXzC[ł̌ύX
procedure TTCalendarDisplayForm.FormMouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin
  ChangeMonth(WheelDelta div WHEEL_DELTA);
end;

/// `揈Ewi`ƃJ_[̕`
procedure TTCalendarDisplayForm.FormPaint(Sender: TObject);
  procedure DrawBk();
  var rc: TRect;
  begin
    rc := Rect(0, 0, ClientWidth, ClientHeight);
    Canvas.Pen.Color := clBlack;
    Frame3D(Canvas, rc, clBlack, clBlack, 1);
    Canvas.FillRect(rc);
    DrawGradation(rc, Canvas, ddVartical, [StartColor, FinishColor])
  end;

begin
  if ShiftKeyPressed then begin
    DrawBk;
  end;
  Drawer.Draw(Canvas, 1, 1);
end;

/// tbNDLLbZ[WAL[ꂽꍇɑĂ
/// MessagecbZ[W̍\
/// *wParamcL[R[h
/// *lParamcerbgɃL[̃Xe[^XĂ܂Bt@XQ
/// *Resultcg܂
procedure TTCalendarDisplayForm.HMKeyboardaction(var Message: TMessage);
var vk : Word;
begin
  case LockKey of
    0: vk := VK_SHIFT;
    1: vk := VK_CONTROL;
    2: vk := VK_MENU;
    3: vk := VK_LWIN;
  else
    vk := 0;
  end;
  // bNL[̏
  if ((Message.WParam = vk) or ((LockKey = 3) and (Message.WParam = VK_RWIN))) and
    not ShowConfig then begin
    if (Message.LParam shr 31 = 0) and not ShiftKeyPressed then
      ShiftKeyKeyDown
    else if (Message.LParam shr 31 = 1) and ShiftKeyPressed then
      ShiftKeyKeyUp;
  end;

end;

/// tbNDLLbZ[WAtbNZbgщꂽƂɑĂ
/// MessagecbZ[W̍\
/// *wParamcZbg1A0
/// *lParamcg܂
/// *Resultcg܂
procedure TTCalendarDisplayForm.HMKeyhookdone(var Message: TMessage);
begin
end;

/// ߃L[ꂽƂɌĂяo
procedure TTCalendarDisplayForm.ShiftKeyKeyDown();
begin
  // EBhE񓧉߂ɂ
  SetWindowLong(Handle, GWL_EXSTYLE,
    GetWindowLong(Handle, GWL_EXSTYLE) xor WS_EX_TRANSPARENT);
  ShiftKeyPressed := true;
  TransparentColor:= false;
  AlphaBlendValue := LockAlpha;
  Invalidate;
end;

/// ߃L[ꂽƂɌĂяo
procedure TTCalendarDisplayForm.ShiftKeyKeyUp();
begin
  // EBhE𓧉߂
  SetWindowLong(Handle, GWL_EXSTYLE,
    GetWindowLong(Handle, GWL_EXSTYLE) or WS_EX_TRANSPARENT);
  ShiftKeyPressed := false;
  TransparentColor := true;
  AlphaBlendValue := NormalAlpha;
  Invalidate;
end;

/// ^C}[vV[W
/// tςĂύXAĕ`̎ws
procedure TTCalendarDisplayForm.TimerTimer(Sender: TObject);
var
  y, m, d: Word;
begin
  if not Self.Focused then begin
    DecodeDate(Now, y, m, d);
    ShowingYear := y;
    ShowingMonth:= m;
  end;

  if (ShowingYear <> Drawer.Year) or
    (ShowingMonth <> Drawer.Month) then begin
    CalendarSetDates(ShowingYear, ShowingMonth);
  end;
end;

// j[ACe               1

procedure TTCalendarDisplayForm.ConfigClick(Sender: TObject);
begin
  ShowDialog(TTCalendarSettingDialog);
  ReloadSettings;
end;

procedure TTCalendarDisplayForm.HideFormClick(Sender: TObject);
begin
  Visible := not Visible;
end;

procedure TTCalendarDisplayForm.ShowChangeMonth(Sender: TObject);
begin
  ChangeMonth(TMenuItem(Sender).Tag);
end;

procedure TTCalendarDisplayForm.AppExitClick(Sender: TObject);
begin
  Application.Terminate;
end;

//

/// ݒǂݍ
procedure TTCalendarDisplayForm.ReloadSettings;
var
  i : Integer;
  cc: TCalendarColor;
const
  WStr : array[0..7] of String = (
    'Colors.Year', 'Colors.Month',
    'Colors.Weekday', 'Colors.Sunday',
    'Colors.Saturday', 'Colors.Holyday',
    'Colors.Specialday', 'Colors.Today');
  clSalmon : TColor = $7280FA;
begin
  with TMemIniFileEx.CreateDef do begin try
    Section         := 'General';
    Drawer.Font.Name
                    := ReadStringS('FontName', Font.Name);
    Drawer.Font.Size
                    := ReadIntegerS('FontSize', Font.Size);
    Drawer.FirstDayOfWeek
                    :=
                      TWeek(EnsureRange(
                        ReadIntegerS('StartWeekDay'), 0, 7));
    LockKey         := ReadIntegerS('LockKey');
    TMyDrawer(Drawer).TodayInCursor
                    := ReadIntegerS('CircleInToday');
    TMyDrawer(Drawer).TodayCursorColor
                    := ReadColorS('CursorColor', clRed);
    case ReadBoolS('TopMost', True) of
      True:
        TopMost(Handle);
      False:
        UnTopMost(Handle);
    end;
    Section := 'BackColor';
    StartColor      := ReadColorS('StartColor', clSalmon);
    FinishColor     := ReadColorS('FinishColor', clYellow);
    Section := 'Transparency';
    NormalAlpha     := ReadIntegerS('NormalMode', 255);
    LockAlpha       := ReadIntegerS('LockMode', 255);
    cc  := TCalendarColor.Create;
    try
      for i := 0 to High(WStr) do begin
        Section       := WStr[i];
        cc.Color      := ReadColorS('Color', clNone);
        cc.ShadowColor:= ReadColorS('ShadowColor', clNone);
        cc.FontStyle  := IntToFontStyle(ReadIntegerS('FontStyle'));
        cc.ShadowPoint := Point(2, 2);
        with Drawer do begin
          case i of
            0: YearColor.Assign(cc);
            1: MonthColor.Assign(cc);
            2: WeekdayColor.Assign(cc);
            3: SundayColor.Assign(cc);
            4: SaturdayColor.Assign(cc);
            5: HolydayColor.Assign(cc);
            6: HighlightDayColor.Assign(cc);
            7: TodayColor.Assign(cc);
          end;
        end;
      end;
    finally
      cc.Free;
    end;
    ReadLines('SpecialDays', SPDay);
    Drawer.HighlightDays := CreateSpecialDayList;
    CalendarUpdate;
  finally
    Free;
  end;
  end;
  ShiftKeyKeyUp;
end;

/// \̕ύXE͈͊OɏoȂ悤ɐ
/// ChangescύX錎EǑ\Ƃ-1
procedure TTCalendarDisplayForm.ChangeMonth(Changes: Integer);
const
  lm = Low(TMonth);
  hm = High(TMonth);
  ly = Low(TYear);
  hy = High(TYear);
begin
  Inc(ShowingMonth, Changes);
  while not InRange(ShowingMonth, lm, hm) do begin
    if ShowingMonth < lm then begin
      Dec(ShowingYear);
      Inc(ShowingMonth, hm);
    end else if ShowingMonth > hm then begin
      Inc(ShowingYear);
      Dec(ShowingMonth, hm);
    end;
  end;
  while not InRange(ShowingYear, ly, hy) do begin
    if ShowingYear < ly then
      ShowingYear := hy
    else if ShowingYear > hy then
      ShowingYear := ly;
  end;
  CalendarSetDates(ShowingYear, ShowingMonth);
end;

/// J_[̔zuXV
procedure TTCalendarDisplayForm.CalendarUpdate;
begin
  with Drawer.GetSize(Canvas) do begin
    ClientWidth := cx + 2;
    ClientHeight:= cy + 2;
  end;
  // ͂ݏo߂
  if BoundsRect.Right > Screen.WorkAreaRect.Right then
    Left := Left - (BoundsRect.Right - Screen.WorkAreaRect.Right);
  if BoundsRect.Bottom > Screen.WorkAreaRect.Bottom then
    Top := Top - (BoundsRect.Bottom - Screen.WorkAreaRect.Bottom);
  Invalidate;
end;

/// J_[\ݒ
procedure TTCalendarDisplayForm.CalendarSetDates(Year, Month: Word);
begin
//  ShowingYear := Year;
//  ShowingMonth:= Month;
  Drawer.SetMonth(Year, Month);
  Drawer.HighlightDays := CreateSpecialDayList;
  CalendarUpdate;
end;

/// XyVZoԂ
function TTCalendarDisplayForm.CreateSpecialDayList: TDays;
var
  i : Integer;
  dayname : String;
  weekname: TWeek;
begin
  // ̓ʓZoāAŴɒǉ
  Result := [];
  for i := 0 to SPDay.Count - 1 do begin
    if Drawer.Month = StrToIntDef(PickConstToken(SPDay[i], '/'), 0) then begin
      dayname := PickConstTokenRev(SPDay[i], '/');
      if (Length(dayname) >= 3) and (dayname[1] = 'w') then begin
        // jw
        case dayname[3] of
          's': weekname := wSun;
          'm': weekname := wMon;
          't': weekname := wTue;
          'w': weekname := wWed;
          'h': weekname := wThu;
          'f': weekname := wFri;
          'a': weekname := wSat;
        else
          weekname := wSun;
        end;
        Include(Result,
          GetDayInWeek(Drawer.Year, Drawer.Month, StrToIntDef(dayname[2], 0), weekname));
      end else
        // tw
        Include(Result, StrToIntDef(dayname, 0));
    end;
  end;
end;

{ TMyDrawer }

/// t`̃I[o[Ch
/// Kv΍Ɂ̕`
procedure TMyDrawer.DoDrawDay(Canvas: TCanvas; Rect: TRect; ADate: TDate;
  DateElement: TDateElements);
var SubRect: TRect; // Tu\pRect
begin
  DoPreDrawDay(Canvas, DateElement);
  inherited;
  (*
    2006/10/08:o[Wȍ~
    SubRect := Rect;
    SubRect.Left := SubRect.Left + RectWidth(Rect) div 2;
    SubRect.Top  := SubRect.Top + RectHeight(Rect) div 2;
    Canvas.Font.Size := Canvas.Font.Size div 2;
    DrawText(Canvas.Handle, PChar(IntToStr(DayOf(ADate - 1))), -1, SubRect, DT_CENTER or DT_VCENTER);
  *)
  if (deToday in DateElement) and (TodayInCursor <> 0) then begin
    Canvas.Pen.Color := TodayCursorColor;
    Canvas.Pen.Width := 2;
    Canvas.Brush.Style := bsClear;
    ZoomRect(Rect, -2,-2);
    case TodayInCursor of
      1: Canvas.Ellipse(Rect);
      2: Canvas.Rectangle(Rect);
      3: begin
        Canvas.MoveTo(Rect.Left, Rect.Bottom - 2);
        Canvas.LineTo(Rect.Right, Rect.Bottom - 2);
      end;
    end;
  end;
end;

procedure TMyDrawer.SetTodayCursorColor(const Value: TColor);
begin
  mTodayCursorColor := Value;
  TCalendarDisplayForm.Invalidate;
end;

procedure TMyDrawer.SetTodayInCursor(const Value: Integer);
begin
  mTodayInCursor := Value;
  TCalendarDisplayForm.Invalidate;
end;

initialization
  ShiftKeyPressed := false;
  ShowConfig      := false;
end.

